// $Header: p:\\graphics\\CVS/src/GraphicsTown/Behavior.cpp,v 1.10 2000/11/29 18:49:30 gleicher Exp $
// GraphicsTown - CS559-2000, sample solution
//
// support for the base class of behaviors as well as a few test behaviors
// none are particularly interesting

#include "GrTown_PCH.H"

#include "Behaviors.H"
#include "GrObject.H"
#include "Objects.H"


Behavior::Behavior(GrObject* o) :
  owner(o), lastV(0)
{
  next = o->behaviors;
  o->behaviors = this;
}
void Behavior::simulateUntil(unsigned long t)
{
  lastV = t;
}

ForwardAlways::ForwardAlways(GrObject* o, float v)
  : Behavior(o), vel(v)
{
}
void ForwardAlways::simulateUntil(unsigned long t)
{
  unsigned long dt = t - lastV;	// how long since last update
  float secs = ((float) dt) / 1000;	// convert ms to sec
  lastV = t;
  owner->transform[3][0] += owner->transform[2][0] * secs * vel;
  owner->transform[3][1] += owner->transform[2][1] * secs * vel;
  owner->transform[3][2] += owner->transform[2][2] * secs * vel;
}

TurnAlways::TurnAlways(GrObject* o, float v)
  : Behavior(o), vel(v)
{
}
void TurnAlways::simulateUntil(unsigned long t)
{
  unsigned long dt = t - lastV;	// how long since last update
  float secs = ((float) dt) / 1000;	// convert ms to sec
  lastV = t;
  Matrix delta, newT;
  rotMatrix(delta,'Y',secs * vel);
  multMatrix(delta,owner->transform,newT);
  copyMatrix(newT,owner->transform);
}

