#ifndef BEHAVIORS_H
#define BEHAVIORS_H
// $Header: p:\\graphics\\CVS/src/GraphicsTown/Behaviors.H,v 1.7 2000/11/29 18:49:30 gleicher Exp $
// GraphicsTown - CS559-2000, sample solution
// (c) 2000 Michael L. Gleicher
//
// This example code should give you some idea as to how my system
// worked.
//
// Behaviors move objects around. Each object has a list of
// behaviors. The behaviors can change the internals of the objects.

class GrObject;

// an attempt to decouple how we decide where something is with what
// the thing is
class Behavior {
public:
  Behavior(GrObject* owner);

  GrObject* owner;				// who to make go
  unsigned long lastV;

  // make it go!
  virtual void simulateUntil(unsigned long);

  Behavior* next;				// linked list
};

// some generic behaviors...

// always makes things go forward - you probably want to change its
// direction using another behavior
class ForwardAlways : public Behavior {
public:
  ForwardAlways(GrObject* owner, float vel = 10);
  float vel;
  virtual void simulateUntil(unsigned long);
};
class TurnAlways : public Behavior {
public:
	TurnAlways(GrObject* owner, float vel = .1);
  float vel;
  virtual void simulateUntil(unsigned long);
};

#endif









