// $Header: p:\\graphics\\CVS/src/GraphicsTown/Main.cpp,v 1.20 2000/11/29 18:49:30 gleicher Exp $
//

#include "GrTown_PCH.H"
#include "GraphicsTownUI.H"
#include "FlyCamera.H"
#include "GrWorld.H"
#include "DrawUtils.H"
#include "Texture.H"
#include "Objects.H"
#include "Behaviors.H"
#include "Cars.H"
#include "Roads.H"
#include "Houses.H"

const int numCars = 100;
const int nGrids = 5;

static GrObject* truck(float size);

int main(int /*argc*/, char** /*argv*/)
{

  // now let's add some objects
  //  Helicopter h;
  //  add(&h);
  //  SpinHelicopterBlade s(&h,1000);
  // make some houses
 
  SubdivisionBlocks s(nGrids,nGrids,6);
  add(&s);

 
  // make an object and let it drive around
  // make a whole bunch of cars...
  Car* c;
  for(int i=0; i<40; i++) {
	  switch(rand() % 3) {
	  case 0: c = new Van(rand()); break;
	  case 1: c = new SUV(rand()); break;
	  case 2: c = new HatchBack(rand()); break;
	  }
	add(c);
	c->ridable = 1;
	Drive* d = new Drive(c,(rand()%theIntersectionsV.size())+1,rand()%4);
 }

  // add some more stuff
  add(new Church,-100,0,100,PI/2.f);

  FlyCamera* fc = new FlyCamera;
  add(fc,1000,20,1000,-1.6f);

  // now make a UI
  GraphicsTownUI grTown;
  grTown.make_window();
  grTown.townView->defaultCamera = fc;
  grTown.window->show();

  Fl::run();
  return 1;
}

